(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-settings', ['exports', '@angular/common/http', '@angular/core'], factory) :
    (factory((global['ngx-settings'] = {}),global.ng.common.http,global.ng.core));
}(this, (function (exports,i1,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxSettingsUtils = /** @class */ (function () {
        function NgxSettingsUtils() {
        }
        /**
         * @param {?} key
         * @param {?} object
         * @return {?}
         */
        NgxSettingsUtils.getValueFromObject = /**
         * @param {?} key
         * @param {?} object
         * @return {?}
         */
            function (key, object) {
                // If key is undefined, return entire object
                if (!key) {
                    return object;
                }
                // Check if key is for root element
                if (key.indexOf("\\.") !== -1) {
                    return object["key"];
                }
                /** @type {?} */
                var keyArr = key.split(".");
                /** @type {?} */
                var value = object[keyArr[0]];
                for (var i = 1; i < keyArr.length; i++) {
                    if (value[keyArr[i]]) {
                        value = value[keyArr[i]];
                    }
                    else {
                        value = null;
                        break;
                    }
                }
                return value;
            };
        return NgxSettingsUtils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxSettingsService = /** @class */ (function () {
        function NgxSettingsService(http, appConfig) {
            this.http = http;
            this.appConfig = appConfig;
        }
        /**
         * @return {?}
         */
        NgxSettingsService.prototype.getSettings = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var promise = this.http
                    .get(this.appConfig["settingsUrl"])
                    .toPromise()
                    .then(( /**
             * @param {?} settings
             * @return {?}
             */function (settings) {
                    _this.settings = settings;
                }))
                    .catch(( /**
             * @param {?} error
             * @return {?}
             */function (error) {
                    console.error("Unable to fetch settings file: " + _this.appConfig["settingsUrl"]);
                    throw error;
                }));
                return promise;
            };
        /**
         * @param {?=} key
         * @param {?=} defaultValue
         * @return {?}
         */
        NgxSettingsService.prototype.get = /**
         * @param {?=} key
         * @param {?=} defaultValue
         * @return {?}
         */
            function (key, defaultValue) {
                /** @type {?} */
                var value = NgxSettingsUtils.getValueFromObject(key, this.settings);
                if (!value) {
                    if (defaultValue) {
                        return defaultValue;
                    }
                    throw new Error("No key found with name: " + key);
                }
                return value;
            };
        NgxSettingsService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: "root"
                    },] }
        ];
        /** @nocollapse */
        NgxSettingsService.ctorParameters = function () {
            return [
                { type: i1.HttpClient },
                { type: undefined, decorators: [{ type: i0.Inject, args: ["appConfig",] }] }
            ];
        };
        /** @nocollapse */ NgxSettingsService.ngInjectableDef = i0.defineInjectable({ factory: function NgxSettingsService_Factory() { return new NgxSettingsService(i0.inject(i1.HttpClient), i0.inject("appConfig")); }, token: NgxSettingsService, providedIn: "root" });
        return NgxSettingsService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxSettingsPipe = /** @class */ (function () {
        function NgxSettingsPipe(settingsService) {
            this.settingsService = settingsService;
        }
        /**
         * @param {?} value
         * @param {?} args
         * @return {?}
         */
        NgxSettingsPipe.prototype.transform = /**
         * @param {?} value
         * @param {?} args
         * @return {?}
         */
            function (value, args) {
                return this.settingsService.get(value, args);
            };
        NgxSettingsPipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: "settingsKey"
                    },] }
        ];
        /** @nocollapse */
        NgxSettingsPipe.ctorParameters = function () {
            return [
                { type: NgxSettingsService }
            ];
        };
        return NgxSettingsPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} settingsService
     * @return {?}
     */
    function getSettings(settingsService) {
        /** @type {?} */
        var factory = ( /**
         * @return {?}
         */function () { return settingsService.getSettings(); });
        return factory;
    }
    var NgxSettingsModule = /** @class */ (function () {
        function NgxSettingsModule() {
        }
        /**
         * @param {?} appConfig
         * @return {?}
         */
        NgxSettingsModule.forRoot = /**
         * @param {?} appConfig
         * @return {?}
         */
            function (appConfig) {
                return {
                    ngModule: NgxSettingsModule,
                    providers: [{ provide: "appConfig", useValue: appConfig }]
                };
            };
        NgxSettingsModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [i1.HttpClientModule],
                        declarations: [NgxSettingsPipe],
                        providers: [
                            NgxSettingsService,
                            {
                                provide: i0.APP_INITIALIZER,
                                useFactory: getSettings,
                                deps: [NgxSettingsService],
                                multi: true
                            }
                        ],
                        exports: [NgxSettingsPipe]
                    },] }
        ];
        return NgxSettingsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.getSettings = getSettings;
    exports.NgxSettingsModule = NgxSettingsModule;
    exports.NgxSettingsService = NgxSettingsService;
    exports.NgxSettingsPipe = NgxSettingsPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-settings.umd.js.map